;; Copyright 2009, 2010 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


(defgroup foo)

(put 'some-variable 'safe-local-variable 'integerp)
(put 'some-variable 'risky-local-variable t)

(defun foo-mode ()
  (interactive)
  nil)

(setq debug-on-quit t)

;;-----------------------------------------------------------------------------
;; run check on many files

(progn
  (load (expand-file-name "../checkdoc-autoload.el"))
  (switch-to-buffer "*d-checkdoc-autoload.el*")
  (dolist (filename (apply 'append
                           (mapcar 'file-expand-wildcards
                                   '("../p/el/wip/*.el"
                                     "../p/el/*.el"
                                     "/usr/share/emacs/site-lisp/*.el"
                                     "/usr/share/emacs/site-lisp/*/*.el"
                                     "/down/emacs/lisp/*.el"
                                     "/down/emacs/lisp/*/*.el"))))

    (erase-buffer)
    (insert-file-contents filename)
    (let ((check (with-temp-message filename
                   (checkdoc-autoload-comment))))
      '(when check
        (insert (format "%s\n" filename))
        (redisplay)))))

;;   (erase-buffer)
;;   (require 'lisp-mnt)
;;                    (lm-with-file filename
;;                      (checkdoc-autoload-comment)))))

;;-----------------------------------------------------------------------------
;; unused

(defun checkdoc-autoload-cookie-p ()
  "Return non-nil if the form before point has an autoload cookie.
This is an internal part of checkdoc-autoload.el."
  (save-excursion
    (backward-sexp)   ;; start of form in question
    (forward-line -1) ;; the line before it
    (looking-at (concat "^" (regexp-quote generate-autoload-cookie) "\n"))))

(defun checkdoc-autoload-defgroup-p (form)
  "Return non-nil if FORM is a `defgroup'.
This is an internal part of checkdoc-autoload.el."
  (eq 'defgroup (car-safe form)))


;;-----------------------------------------------------------------------------
;; unused, checkdoc not really meant for a .emacs file

`risky-local-variable' settings in .emacs itself are pre-loaded
so `checkdoc-autoload-risky' does nothing on a .emacs buffer.

  (unless (and buffer-file-name
               (checkdoc-autoload-filename-dotemacs-p buffer-file-name))

(defun checkdoc-autoload-filename-dotemacs-p (form)
  "Return non-nil if FORM is a .emacs file.
The basename part of FILENAME is examined and can be .emacs,
.emacs.el and the ms-dos variants _emacs or _emacs.el."
  (member (file-name-nondirectory buffer-file-name)
          '(".emacs"
            ".emacs.el"
            "_emacs"
            "_emacs.el")))


;;-----------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))

