;; Copyright 2008, 2009, 2010, 2012, 2013, 2016 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;;-----------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))


;;--------------------------------
;; wmii.png

;;--------------------------------
;; 0x0A after IEND
;;   /usr/share/icons/wmii.png
;;   /usr/share/mozart/doc/wp/latex1.png
;;
;; actually windows PC bitmap
;;   /usr/share/games/airstrike/ball.png

(progn
  (setq data (with-temp-buffer
               (set-buffer-multibyte nil)
               (insert-file-contents-literally "/usr/share/mozart/doc/wp/latex1.png")
               (buffer-string)))
  (imagetext-png-strings data))

(create-image "/usr/share/games/airstrike/ball.png")

;;--------------------------------
;; auto-image-file-mode

(progn
  (add-to-list 'load-path (expand-file-name ".."))
  (or (locate-library "bindat")
      (add-to-list 'load-path "../21"))
  (eval-after-load "image-file" '(require 'imagetext))
  (auto-image-file-mode 1))

(progn
  (get-buffer-create "x")
  (switch-to-buffer "x")
  ;; (set-buffer-multibyte nil)
  (insert-file-contents "~/image/samples/utf8.png"))

(progn
  (get-buffer-create "x")
  (switch-to-buffer "x")
  (set-buffer-multibyte nil)
  (insert-file-contents "/down/charting/ilrs/Tillson9801_files/SCLOGOSub.gif"))


;;--------------------------------

(setq image-mode-hook nil)
(add-hook    'image-mode-hook 'imagetext-show)
(remove-hook 'image-mode-hook 'imagetext-show)
(remove-hook 'image-mode-hook 'scroll-1-keybindings)
(add-hook    'image-mode-hook 'scroll-1-keybindings)
(clear-image-cache)
(setq debug-on-error t)

(progn
  (let ((image (create-image (expand-file-name "~/Downloads/fractals/ds_dynamical systems - On the boundary of the twindragon - MathOverflow_files/1Gy4C.gif"))))
    (switch-to-buffer "x")
    (insert-image image)))

(progn
  (setq data (with-temp-buffer
               (set-buffer-multibyte nil)
               (insert-file-contents-literally "~/Downloads/fractals/ds_dynamical systems - On the boundary of the twindragon - MathOverflow_files/1Gy4C.gif")
               (buffer-string)))
  (imagetext-gif-strings data))

(progn
  (setq data (with-temp-buffer
               (set-buffer-multibyte nil)
               (insert-file-contents-literally "/tmp/screenshot.png")
               (buffer-string)))
  (imagetext-png-strings data))

(progn
  (setq data (with-temp-buffer
               (set-buffer-multibyte nil)
               (insert-file-contents-literally "/down/ding/backup/texi/misc/ered.tif")
               (buffer-string)))
  (substring data 0 8)
  (imagetext-tiff-strings data)
  )

(progn
  (setq data (with-temp-buffer
               (set-buffer-multibyte nil)
               (insert-file-contents-literally "/home/gg/image/samples/sony-powershota5.jpg")
               (buffer-string)))
  (substring data 0 8)
  (imagetext-jpeg-strings data)
  )

(setq im (create-image "/home/gg/image/samples/sony-powershota5.jpg"))
(setq im (create-image data nil t))
(image-size im)
(imagetext-size-strings im)

(progn
  (add-to-list 'load-path (expand-file-name ".."))
  (or (locate-library "bindat")
      (add-to-list 'load-path "../21"))
  (eval-after-load "image-file" '(require 'imagetext))
  (auto-image-file-mode 1))

(progn
  (add-to-list 'load-path (expand-file-name ".."))
  (autoload 'imagetext-show "imagetext")
  (add-hook 'image-mode-hook 'imagetext-show))

(find-file "../test/imagetext")

;;-----------------

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))

(compile "cd ..; set -x;
emacs-cvs-b -batch -q -no-site-file -f batch-byte-compile imagetext.el;
emacs23     -batch -q -no-site-file -f batch-byte-compile imagetext.el;
emacs22     -batch -q -no-site-file -f batch-byte-compile imagetext.el;
emacs21     -batch -q -no-site-file -f batch-byte-compile imagetext.el;
xemacs21    -batch -q -no-site-file -l /down/emacs/lisp/emacs-lisp/bindat.el -f batch-byte-compile imagetext.el;
rm imagetext.elc")

(compile "cd $HOME/lisp; set -x;
emacs-cvs-b -batch -q -no-site-file -f batch-byte-compile image-mode.el;
emacs22     -batch -q -no-site-file -f batch-byte-compile image-mode.el;
rm image-mode.elc")

;;-----------------
;; churn to check all available image  files
(setq i (create-image "~/image/samples/ct1n0g04.png"))
(setq i (create-image "/so/gtk/gtk+-2.0.0/demos/gtk-demo/floppybuddy.gif"))
(setq i (create-image "/down/charting/ilrs/Tillson9801_files/SCLOGOSub.gif"))

(image-extension-data i)
(image-size i)

(find-file "/tmp/x.png")



(progn
  (switch-to-buffer "x")
  (imagetext-png-strings))


(let ((end   (make-marker))
      (count 0))
  (require 'imagetext)

  (add-to-list 'auto-coding-alist '("\\.jpe?g" . no-conversion))
  (add-to-list 'auto-coding-alist '("\\.gif"   . no-conversion))
  (add-to-list 'auto-coding-alist '("\\.png"   . no-conversion))

  (defun my-locate (pattern)
    (with-temp-buffer
      (call-process "locate" nil t nil
                    pattern)
      (split-string (buffer-string) "\n" t)))

  (defun my-map-check (proc suffix)

    (let* ((lst (my-locate suffix))
           (done 0)
           (rep  (make-progress-reporter (format "Checking %s ... " suffix)
                                         0 (length lst))))

      (set-buffer (get-buffer-create "*t-imagetext--temp*"))
      (set-buffer-multibyte nil)
      (buffer-disable-undo)

      (dolist (filename lst)
        (when (file-exists-p filename)
          (sit-for 0)
          (erase-buffer)
          (insert-file-contents-literally filename)
          (let* ((raw   (buffer-string))
                 (image (ignore-errors (create-image raw nil t))))
            (if image
                (condition-case err
                    (imagetext-strings image raw)
                  (error
                   (with-current-buffer (get-buffer-create "*errors*")
                     (let ((str (car err)))
                       (message "%s" str)
                       (insert (format "%s\n  %s\n" filename str))))))

              (with-current-buffer (get-buffer-create "*errors*")
                (let ((str "unrecognised"))
                  (message "%s" str)
                  (insert (format "%s\n  %s\n" filename str))))))

          (setq count (1+ count)))

        (setq done (1+ done))
        (progress-reporter-update rep done))

      (progress-reporter-done rep)
      (message "%d tests" count)))

  (with-current-buffer (get-buffer-create "*errors*")
    (erase-buffer))
  (my-map-check 'imagetext-png-strings  "*.png")
  (my-map-check 'imagetext-jpeg-strings "*.jpg")
  (my-map-check 'imagetext-gif-strings  "*.gif")
  (my-map-check 'imagetext-jpeg-strings "*.jpeg")
  (switch-to-buffer "*errors*")
  (goto-char (point-min)))

(length (my-locate ".png"))
(length (my-locate ".jpg"))
(length (my-locate ".gif"))


(compare-strings "" 0 6 "Exif\000\000" 0 6)

(imagetext-tumme-string "xx")
(imagetext-tumme-string "/home/gg/image/samples/guptrade.gif")
(imagetext-tumme-string "/home/gg/image/samples/chart.xpm")
(imagetext-tumme-string "/home/gg/image/samples/canon-ixus.jpg")
(image-dired-get-comment "xx")
(image-dired-get-comment "/home/gg/image/samples/guptrade.gif")
(image-dired-get-comment "/home/gg/image/samples/chart.xpm")
(image-dired-list-tags "/home/gg/image/samples/chart.xpm")
(image-dired-list-tags "/home/gg/image/samples/guptrade.gif")
(image-dired-list-tags "xx")



(setq debug-on-error t)
(dotimes (i 8615)
  (if (/= (aref foo i) (aref bar i))
      (error  "differ at %d %X  %X %X  %X %X"
              i i
              (aref foo i) (aref bar i)
              (aref foo (1+ i)) (aref bar (1+ i)))))


(let (ret)
  (with-temp-buffer
    (set-buffer-multibyte nil)
    (insert-file-contents-literally
     "/tmp/d-mine-sweeper-auto--screenshot.png"
     nil
     #x730 #x732)
    (push (buffer-string) ret)
    (push (length (buffer-string)) ret)
    (set-buffer-multibyte nil)
    (push (length (buffer-string)) ret)
    (set-buffer-multibyte t)
    (push (length (buffer-string)) ret)
    (set-buffer-multibyte nil)
    (push (length (buffer-string)) ret)
    (push (buffer-string) ret)
    (setq quux (buffer-string))
    (push (length quux) ret)
    ret))


(with-temp-buffer
  (set-buffer-multibyte nil)
  (insert #xC0 #x84)
  (set-buffer-multibyte t)
  (set-buffer-multibyte nil)
  (- (point-max) (point-min)))


(progn
  (switch-to-buffer "x")
  (set-buffer-multibyte nil)
  (insert #xC0 #x84)
  (set-buffer-multibyte t)
  (goto-char (point-min))
  (describe-char (point-min)))
