# Copyright 2007, 2009, 2012, 2016, 2017 Kevin Ryde.

# This file is part of miscbits-el.
#
# miscbits-el is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 3, or (at your option) any later
# version.
#
# miscbits-el is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with miscbits-el; see the file COPYING.  Failing that, go to
# <http://www.gnu.org/licenses/>.


(progn
  (add-to-list 'load-path "..")
  (require 'sh-autoconf)

  (find-file "configure.in")
  (sh-mode)
  (font-lock-mode))

;;-----------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))

;;-----------------

;; info-lookup-alist

(let* ((symalist   (cdr (assq 'symbol info-lookup-alist)))
       (shentry    (assq 'sh-mode symalist))
       (otherpos   (nthcdr 5 shentry))
       (othermodes (car otherpos)))
  (unless (memq 'autoconf-mode othermodes)
    (setq othermodes (append othermodes '(autoconf-mode)))
    othermodes
    symalist
    shentry
    ))



;;-----------------

(when (ad-find-advice 'sh-syntax-propertize-function 'after 'sh-autoconf)
  (ad-remove-advice   'sh-syntax-propertize-function 'after 'sh-autoconf)
  (ad-activate        'sh-syntax-propertize-function))

(when (eval-when-compile (fboundp 'sh-syntax-propertize-function))
  (defadvice sh-syntax-propertize-function (after sh-autoconf activate)
    (funcall (syntax-propertize-rules ("\\<dnl\\>" (0 "_")))
             start end)))

