;; Copyright 2010 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.



(progn
  (load (expand-file-name "my-load-all.el"))
  (my-load-all--libraries))

(progn
  (kill-buffer (get-buffer-create "*Warnings*"))
  (require 'cl)
  (dolist (dir load-path)
    (let ((lst (file-expand-wildcards (concat dir "/*.elc"))))
      (dolist (el (file-expand-wildcards (concat dir "/*.el")))
        (setq lst (remove (concat el "c") lst))
        (push el lst))
      (my-emacs-info-xref-docstrings lst))))

(my-emacs-info-xref-docstrings (file-expand-wildcards "~/p/el/*.el"))
(my-emacs-info-xref-docstrings (file-expand-wildcards "/down/emacs/src/*.c"))
(my-emacs-info-xref-docstrings '("/down/emacs/b/etc/DOC"))

(defun my-emacs-info-xref-docstrings (filename-list)
  (require 'info-xref)
  (require 'lisp-mnt)
  (require 'help-mode)
  (dolist (filename filename-list)
    (lm-with-file filename
      (goto-char (point-min))
      (while (re-search-forward help-xref-info-regexp nil t)
        (let ((match (match-string 0))
              (node  (match-string 2)))
          (save-match-data ;; for the while loop
            (unless (string-match "\\`(" node)
              (setq node (concat "(emacs)" node)))
            (setq match (replace-regexp-in-string "\n" " " match))
            (setq node (replace-regexp-in-string "\n" " " node))
            (unless (or (string-match "%" node)
                        (info-xref-goto-node-p node))
              (lwarn 'emacs-info-xref-docstrings 'warning
                     "\n  %s:\n  no such node: %S"
                     filename match))))))))



(progn
  (require 'cl)
  (require 'info-xref)
  (with-temp-buffer
    (mapatoms (lambda (symbol)
                (loop for str in (list (and (fboundp symbol)
                                            (documentation symbol))
                                       (documentation-property
                                        symbol 'variable-documentation t))
                      if str do
                      (erase-buffer)
                      (insert str)
                      (goto-char (point-min))
                      (while (re-search-forward help-xref-info-regexp nil t)
                        (let ((node (match-string 2)))
                          (save-match-data ;; for the while loop
                            (unless (string-match "\\`(" node)
                              (setq node (concat "(emacs)" node)))
                            (setq node
                                  (replace-regexp-in-string "\n" " " node)))
                          (unless (info-xref-goto-node-p node)
                            (lwarn 'emacs-info-xref-docstrings 'warning
                                   "`%S' no such node: %S\n"
                                   symbol node)))))))))
