;; Copyright 2009 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.

(require 'info-look)

(defun my-info-lookup-test (mode)
  (interactive "S")
  (dolist (topic '(symbol file))
    (let ((regexp (concat "\\`\\(" (info-lookup->regexp topic mode) "\\)\\'"))
          (buffer (get-buffer-create "*info-lookup-test*")))
      (switch-to-buffer buffer)
      (erase-buffer)
      (insert (format "mode %s\n" (symbol-name mode)))
      (sit-for 0)
      (dolist (item (info-lookup-make-completions 'symbol 'emacs-lisp-mode))
        (when (string-match regexp (car item))
          (info-lookup-symbol (car item) mode)
          (when (or (not info-lookup-highlight-overlay)
                    (not (overlay-start info-lookup-highlight-overlay))
                    (not (overlay-end   info-lookup-highlight-overlay))
                    (=   (overlay-start info-lookup-highlight-overlay)
                         (overlay-end   info-lookup-highlight-overlay)))
            (insert (format "No match `%s'%s\n" (car item)
                            (if (cdr item) (concat ": " (cdr item)) "")))
            (sit-for 0)
            ))))))

(my-info-lookup-test 'emacs-lisp-mode)
