;; Copyright 2002, 2009 Kevin Ryde

;; yes-or-no-condition.el is free software; you can redistribute it and/or
;; modify it under the terms of the GNU General Public License as published
;; by the Free Software Foundation; either version 3, or (at your option)
;; any later version.
;;
;; yes-or-no-condition.el is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You can get a copy of the GNU General Public License online at
;; <http://www.gnu.org/licenses/>.


(defun yes-or-no-condition-p (prompt condfunc)
  (let ((result (if (funcall condfunc)
                    'again
                  'n/a)))
    (while (eq result 'again)
      (let ((answer (downcase (read-from-minibuffer
                               prompt nil nil nil yes-or-no-p-history
                               nil nil))))
        (cond ((equal answer "yes")
               (setq result t))
              ((equal answer "no")
               (setq result nil))
              ((not (funcall condfunc))
               (setq result 'n/a))
              (t
               (ding)
               (discard-input)
               (message "Please answer yes or no.")
               (sleep-for 2)))))
    result))

